<?xml version="1.0"?>
<definitions name="ReplaceAWithBProcess"
        targetNamespace="http://www.uca.es/bpel"
        xmlns:tns="http://www.uca.es/bpel"
        xmlns:plnk="http://docs.oasis-open.org/wsbpel/2.0/plnktype"
        xmlns="http://schemas.xmlsoap.org/wsdl/"
        xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/"
        >

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     TYPE DEFINITION - List of types participating in this BPEL process 
     The BPEL Designer will generate default request and response types
     but you can define or import any XML Schema type and use them as part 
     of the message types.
     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->    
    <types>
        <schema attributeFormDefault="unqualified" elementFormDefault="qualified" 
                targetNamespace="http://www.uca.es/bpel" 
                xmlns="http://www.w3.org/2001/XMLSchema">

            <element name="ReplaceAWithBProcessRequest">
                <complexType>
                    <sequence maxOccurs="unbounded" minOccurs="0">
                        <element name="a" type="string"/>
                    </sequence>
                </complexType>
            </element>

            <element name="ReplaceAWithBProcessResponse">
                <complexType>
                    <sequence maxOccurs="unbounded" minOccurs="0">
                        <element name="b" type="string"/>
                    </sequence>
                </complexType>
            </element>
        </schema>
    </types>


<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     MESSAGE TYPE DEFINITION - Definition of the message types used as 
     part of the port type defintions
     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->    
    <message name="ReplaceAWithBProcessRequestMessage">
        <part name="payload" element="tns:ReplaceAWithBProcessRequest"/>
    </message>
    <message name="ReplaceAWithBProcessResponseMessage">
        <part name="payload" element="tns:ReplaceAWithBProcessResponse"/>
    </message>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     PORT TYPE DEFINITION - A port type groups a set of operations into
     a logical service unit.
     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->    

    <!-- portType implemented by the ReplaceAWithBProcess BPEL process -->
    <portType name="ReplaceAWithBProcess">
        <operation name="process">
            <input  message="tns:ReplaceAWithBProcessRequestMessage" />
            <output message="tns:ReplaceAWithBProcessResponseMessage"/>
        </operation>
    </portType>   
<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     PARTNER LINK TYPE DEFINITION
     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->    
    <plnk:partnerLinkType name="ReplaceAWithBProcess">
        <plnk:role name="ReplaceAWithBProcessProvider" portType="tns:ReplaceAWithBProcess"/>
    </plnk:partnerLinkType>
    

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     BINDING DEFINITION - Defines the message format and protocol details
     for a web service.
     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
    <binding name="ReplaceAWithBProcessBinding" type="tns:ReplaceAWithBProcess">
    	<soap:binding style="document"
    		transport="http://schemas.xmlsoap.org/soap/http" />
    	<operation name="process">
    		<soap:operation
    			soapAction="http://www.uca.es/bpel/process" />
    		<input>
    			<soap:body use="literal" />
    		</input>
    		<output>
    			<soap:body use="literal" />
    		</output>
    	</operation>
    </binding>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     SERVICE DEFINITION - A service groups a set of ports into
     a service unit.
     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
    <service name="ReplaceAWithBProcessService">
    	<port name="ReplaceAWithBProcessPort" binding="tns:ReplaceAWithBProcessBinding">
    		<soap:address location="http://localhost:8080/active-bpel/services/ReplaceAWithBProcessService" />
    	</port>
    </service>
</definitions>
